/* ntdisp - NtD In System Programming.
 *
 * Copyright (C) 2012  Nicola Fontana <ntd at entidi.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __NTD_REGEX_ENTRY_H__
#define __NTD_REGEX_ENTRY_H__


G_BEGIN_DECLS

#define NTD_TYPE_REGEX_ENTRY             (ntd_regex_entry_get_type())
#define NTD_REGEX_ENTRY(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), NTD_TYPE_REGEX_ENTRY, NtdRegexEntry))
#define NTD_REGEX_ENTRY_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), NTD_TYPE_REGEX_ENTRY, NtdRegexEntryClass))
#define NTD_IS_REGEX_ENTRY(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), NTD_TYPE_REGEX_ENTRY))
#define NTD_IS_REGEX_ENTRY_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), NTD_TYPE_REGEX_ENTRY))
#define NTD_REGEX_ENTRY_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS((obj), NTD_TYPE_REGEX_ENTRY, NtdRegexEntryClass))

typedef struct _NtdRegexEntry        NtdRegexEntry;
typedef struct _NtdRegexEntryClass   NtdRegexEntryClass;

struct _NtdRegexEntry {
    /*< private >*/
    GtkEntry             parent;
    gpointer             data;
};

struct _NtdRegexEntryClass {
    /*< private >*/
    GtkEntryClass        parent_class;
    /*< public >*/
    /* Virtual Table */
    void                (*validity_changed)         (NtdRegexEntry  *entry);
};


GType           ntd_regex_entry_get_type            (void) G_GNUC_CONST;

GtkWidget *     ntd_regex_entry_new                 (void);
GtkWidget *     ntd_regex_entry_new_with_regex      (const gchar    *regex);
void            ntd_regex_entry_set_regex           (NtdRegexEntry  *entry,
                                                     const gchar    *regex);
const gchar *   ntd_regex_entry_get_regex           (NtdRegexEntry  *entry);
void            ntd_regex_entry_validate            (NtdRegexEntry  *entry);
void            ntd_regex_entry_set_validity        (NtdRegexEntry  *entry,
                                                     gboolean        is_valid);
gboolean        ntd_regex_entry_get_validity        (NtdRegexEntry  *entry,
                                                     gboolean        fallback);
void            ntd_regex_entry_validity_changed    (NtdRegexEntry  *entry);

G_END_DECLS


#endif /* __NTD_REGEX_ENTRY_H__ */
