/* ntdisp - NtD In System Programming.
 *
 * Copyright (C) 2012  Nicola Fontana <ntd at entidi.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __NTD_NULL_H__
#define __NTD_NULL_H__


G_BEGIN_DECLS

#define NTD_TYPE_NULL             (ntd_null_get_type ())
#define NTD_NULL(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), NTD_TYPE_NULL, NtdNull))
#define NTD_NULL_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), NTD_TYPE_NULL, NtdNullClass))
#define NTD_IS_NULL(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NTD_TYPE_NULL))
#define NTD_IS_NULL_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), NTD_TYPE_NULL))
#define NTD_NULL_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), NTD_TYPE_NULL, NtdNullClass))


typedef struct _NtdNull           NtdNull;
typedef struct _NtdNullClass      NtdNullClass;

struct _NtdNull {
    /*< private >*/
    NtdDevice              device;
};

struct _NtdNullClass {
    /*< private >*/
    NtdDeviceClass         parent_class;
};


GType                   ntd_null_get_type       (void) G_GNUC_CONST;
NtdDevice*              ntd_null_new            (void);

G_END_DECLS


#endif /* __NTD_NULL_H__ */
