/* ntdisp - NtD In System Programming.
 *
 * Copyright (C) 2012  Nicola Fontana <ntd at entidi.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __NTD_SERIAL_PRIVATE_H__
#define __NTD_SERIAL_PRIVATE_H__


G_BEGIN_DECLS

typedef struct _NtdSerialPrivate NtdSerialPrivate;

struct _NtdSerialPrivate {
    gpointer            implementation;
    gboolean            exclusive;
    NtdBaud             baud;
    NtdParity           parity;
    NtdDataBits         data_bits;
    NtdStopBits         stop_bits;
    NtdSoftwareFlow     software_flow;
    NtdHardwareFlow     hardware_flow;
    gdouble             timeout;
};


void            _ntd_serial_open                (NtdDevice*     device);
void            _ntd_serial_close               (NtdDevice*     device);
void            _ntd_serial_flush               (NtdDevice*     device,
                                                 gboolean       input,
                                                 gboolean       output);
gsize           _ntd_serial_raw_read            (NtdDevice*     device,
                                                 gsize          nbytes,
                                                 gpointer       buffer);
gsize           _ntd_serial_raw_write           (NtdDevice*     device,
                                                 gsize          nbytes,
                                                 gconstpointer  buffer);

G_END_DECLS


#endif /* __NTD_SERIAL_PRIVATE_H__ */
