/* ntdisp - NtD In System Programming.
 *
 * Copyright (C) 2012  Nicola Fontana <ntd at entidi.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __NTD_STM_H__
#define __NTD_STM_H__


G_BEGIN_DECLS

#define NTD_TYPE_STM             (ntd_stm_get_type())
#define NTD_STM(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), NTD_TYPE_STM, NtdStm))
#define NTD_STM_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), NTD_TYPE_STM, NtdStmClass))
#define NTD_IS_STM(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), NTD_TYPE_STM))
#define NTD_IS_STM_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), NTD_TYPE_STM))
#define NTD_STM_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS((obj), NTD_TYPE_STM, NtdStmClass))

typedef struct _NtdStm        NtdStm;
typedef struct _NtdStmClass   NtdStmClass;

struct _NtdStm {
    /*< private >*/
    NtdIsp             parent;
    gpointer             data;
};

struct _NtdStmClass {
    /*< private >*/
    NtdIspClass        parent_class;
    /*< public >*/
    /* Signals */
};


GType           ntd_stm_get_type                (void) G_GNUC_CONST;
NtdStm*         ntd_stm_new                     (void);
NtdStm*         ntd_stm_new_with_device         (const gchar*   device);

void            ntd_stm_set_pid                 (NtdStm*        stm,
                                                 guint          pid);
guint           ntd_stm_get_pid                 (NtdStm*        stm);
void            ntd_stm_set_version             (NtdStm*        stm,
                                                 const gchar*   version);
const gchar*    ntd_stm_get_version             (NtdStm*        stm);
void            ntd_stm_set_code_table          (NtdStm*        stm,
                                                 const guchar*  code_table);
const guchar*   ntd_stm_get_code_table          (NtdStm*        stm);
void            ntd_stm_set_flash_base          (NtdStm*        stm,
                                                 gulong         flash_base);
gulong          ntd_stm_get_flash_base          (NtdStm*        stm);
gboolean        ntd_stm_command                 (NtdStm*        stm,
                                                 NtdStmCommand  command);
gboolean        ntd_stm_data                    (NtdStm*        stm,
                                                 gconstpointer  data,
                                                 guint          data_size);
NtdStmAnswer    ntd_stm_answered                (NtdStm*        stm);

G_END_DECLS


#endif /* __NTD_STM_H__ */
