/* ntdisp - NtD In System Programming.
 *
 * Copyright (C) 2012  Nicola Fontana <ntd at entidi.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __NTDISP_ENUMS_H__
#define __NTDISP_ENUMS_H__


G_BEGIN_DECLS

/* This header file MUST follow this style to cope with glib-mkenums:
 * the regex used is /\s*typedef\s+enum\s*({)?.../.
 *
 * Check the sources for up to date information and further details:
 * http://git.gnome.org/browse/glib/tree/gobject/glib-mkenums.in
 */

typedef enum {
    NTD_BAUD_UNKNOWN = 0,
    NTD_BAUD_50      = 50,
    NTD_BAUD_75      = 75,
    NTD_BAUD_110     = 110,
    NTD_BAUD_134     = 134,
    NTD_BAUD_200     = 200,
    NTD_BAUD_300     = 300,
    NTD_BAUD_600     = 600,
    NTD_BAUD_1200    = 1200,
    NTD_BAUD_1800    = 1800,
    NTD_BAUD_2400    = 2400,
    NTD_BAUD_4800    = 4800,
    NTD_BAUD_9600    = 9600,
    NTD_BAUD_19200   = 19200,
    NTD_BAUD_38400   = 38400,
    NTD_BAUD_57600   = 57600,
    NTD_BAUD_115200  = 115200,
    NTD_BAUD_230400  = 230400,
    NTD_BAUD_460800  = 460800
} NtdBaud;

typedef enum {
    NTD_PARITY_UNKNOWN,
    NTD_PARITY_NONE,
    NTD_PARITY_ODD,
    NTD_PARITY_EVEN,
    NTD_PARITY_UNCHECK
} NtdParity;

typedef enum {
    NTD_DATA_BITS_UNKNOWN = 0,
    NTD_DATA_BITS_5       = 5,
    NTD_DATA_BITS_6       = 6,
    NTD_DATA_BITS_7       = 7,
    NTD_DATA_BITS_8       = 8
} NtdDataBits;

typedef enum {
    NTD_STOP_BITS_UNKNOWN = 0,
    NTD_STOP_BITS_1       = 1,
    NTD_STOP_BITS_1_5     = 15,
    NTD_STOP_BITS_2       = 2
} NtdStopBits;

typedef enum {
    NTD_SOFTWARE_FLOW_NONE,
    NTD_SOFTWARE_FLOW_XON,
    NTD_SOFTWARE_FLOW_XOFF,
    NTD_SOFTWARE_FLOW_XON_XOFF
} NtdSoftwareFlow;

typedef enum {
    NTD_HARDWARE_FLOW_NONE,
    NTD_HARDWARE_FLOW_RTS,
    NTD_HARDWARE_FLOW_CTS,
    NTD_HARDWARE_FLOW_RTS_CTS
} NtdHardwareFlow;

typedef enum {
    NTD_STM_COMMAND_GET = 0,
    NTD_STM_COMMAND_GET_VERSION,
    NTD_STM_COMMAND_GET_ID,
    NTD_STM_COMMAND_READ,
    NTD_STM_COMMAND_GO,
    NTD_STM_COMMAND_WRITE,
    NTD_STM_COMMAND_ERASE,
    NTD_STM_COMMAND_WRITE_PROCTECT,
    NTD_STM_COMMAND_WRITE_UNPROCTECT,
    NTD_STM_COMMAND_READ_PROCTECT,
    NTD_STM_COMMAND_READ_UNPROCTECT
} NtdStmCommand;

typedef enum {
    NTD_STM_ANSWER_NONE,
    NTD_STM_ANSWER_ACK,
    NTD_STM_ANSWER_NAK,
    NTD_STM_ANSWER_UNKNOWN
} NtdStmAnswer;

G_END_DECLS


#endif /* __NTDISP_ENUMS_H__ */
