/* ntdisp - NtD In System Programming.
 *
 * Copyright (C) 2012  Nicola Fontana <ntd at entidi.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __NTDISP_INTL_H__
#define __NTDISP_INTL_H__


#ifndef PACKAGE
# error config.h must be included before this file.
#endif


#ifdef ENABLE_NLS

#ifndef GETTEXT_PACKAGE
#define GETTEXT_PACKAGE PACKAGE
#endif

#include <libintl.h>

#if ! GLIB_CHECK_VERSION(2, 18, 0)
/* Backward compatibility fallback */
#define g_dgettext              dgettext
#endif

#ifdef gettext_noop
#define N_(String)              gettext_noop(String)
#else
#define N_(String)              (String)
#endif

#define _(String)               g_dgettext(GETTEXT_PACKAGE, String)
#define P_(String)              g_dgettext(GETTEXT_PACKAGE "-properties", String)
#define Q_(String)              g_dpgettext(GETTEXT_PACKAGE, String, 0)
#define C_(Context,String)      g_dpgettext(GETTEXT_PACKAGE, Context "\004" String, strlen(Context) + 1)
#define NC_(Context,String)     N_(String)

#else /* ! ENABLE_NLS */

#define _(String)               (String)
#define P_(String)              (String)
#define Q_(String)              (String)
#define N_(String)              (String)
#define C_(Context,String)      (String)
#define NC_(Context, String)    (String)

#endif /* ENABLE_NLS */


#endif /* __NTDISP_INTL_H__ */
